#include "hmi_driver.h"
#include "hmi_user_uart.h"
#include "cmd_queue.h"
#include "cmd_process.h"
#include "stdio.h"

#include "../CPrintf.h"
#include "../UILogic/pageCommon.h"

#ifdef __cplusplus
extern "C" {
#endif

//uint8 cmd_buffer[CMD_MAX_SIZE];

//#define TIME_100MS 10
//
//volatile uint32  timer_tick_count = 0; //ʱ
//
//uint8 cmd_buffer[CMD_MAX_SIZE];
//
//static int32 test_value = 0;
//static uint8 update_en = 0;
//
//void UpdateUI(void);

#if 0

//
int main()
{
	qsize  size = 0;
	uint32 timer_tick_last_update = 0;

	/*ʱ*/
	Set_System();
	/*ôж*/
	Interrupts_Config();
	/*ʱӽ*/
	systicket_init();

	/*ڳʼ,Ϊ115200*/
	UartInit(115200);

	/*մڽջ*/
	queue_reset();

	/*ʱȴʼ,ȴ300ms*/
	delay_ms(300);

	while(1)
	{
		size = queue_find_cmd(cmd_buffer,CMD_MAX_SIZE); //ӻлȡһָ        
		if(size>0)//յָ
		{
			ProcessMessage((PCTRL_MSG)cmd_buffer, size);//ָ
		}		

		/****************************************************************************************************************
		رע
		MCUҪƵ򴮿ݣ򴮿ڲӶݶʧ(С׼8K4.7K)
		1) һ£MCU򴮿ݵڴ100msͿԱݶʧ⣻
		2) Ȼݶʧ⣬жϴBUSYţΪʱܷݸ
		******************************************************************************************************************/

		//TODO: û
		//иʱÿ100ˢһ
		if(update_en&&timer_tick_count-timer_tick_last_update>=TIME_100MS)
		{
			update_en = 0;
			timer_tick_last_update = timer_tick_count;			

			UpdateUI();
		}
	}
}

#endif

/*! 
 *  \brief  Ϣ̣˴һ㲻Ҫ
 *  \param msg Ϣ
 *  \param size Ϣ
 */
void ProcessMessage( PCTRL_MSG msg, uint16 size )
{
	uint8 cmd_type = msg->cmd_type;//ָ
	uint8 ctrl_msg = msg->ctrl_msg;   //Ϣ
	uint8 control_type = msg->control_type;//ؼ
	uint16 screen_id = PTR2U16(&msg->screen_id_high);//ID
	uint16 control_id = PTR2U16(&msg->control_id_high);//ؼID
	uint32 value = PTR2U32(msg->param);//ֵ

	switch(cmd_type)
	{		
	case NOTIFY_TOUCH_PRESS://
	case NOTIFY_TOUCH_RELEASE://ɿ
		//NotifyTouchXY(cmd_buffer[1],PTR2U16(cmd_buffer+2),PTR2U16(cmd_buffer+4));
		break;	
	case NOTIFY_WRITE_FLASH_OK://дFLASHɹ
		NotifyWriteFlash(1);
		break;
	case NOTIFY_WRITE_FLASH_FAILD://дFLASHʧ
		NotifyWriteFlash(0);
		break;
	case NOTIFY_READ_FLASH_OK://ȡFLASHɹ
		//NotifyReadFlash(1,cmd_buffer+2,size-6);//ȥ֡ͷ֡β
		break;
	case NOTIFY_READ_FLASH_FAILD://ȡFLASHʧ
		//NotifyReadFlash(0,0,0);
		break;
	case NOTIFY_READ_RTC://ȡRTCʱ
		//NotifyReadRTC(cmd_buffer[1],cmd_buffer[2],cmd_buffer[3],cmd_buffer[4],cmd_buffer[5],cmd_buffer[6],cmd_buffer[7]);
		break;
	case NOTIFY_CONTROL:
		{
			if(ctrl_msg==MSG_GET_CURRENT_SCREEN)//ID仯֪ͨ
			{
				NotifyScreen(screen_id);
			}
			else
			{
				switch(control_type)
				{
				case kCtrlButton: //ťؼ
					cDebug("NotifyButton(), %d, %d, %d\n", screen_id, control_id, msg->param[1]);
					NotifyButton(screen_id,control_id,msg->param[1]);
					break;
				case kCtrlText://ıؼ
					cDebug("NotifyText(), %d, %d, %s\n", screen_id, control_id, msg->param);
					NotifyText(screen_id,control_id,msg->param);
					break;
				case kCtrlProgress: //ؼ
					NotifyProgress(screen_id,control_id,value);
					break;
				case kCtrlSlider: //ؼ
					NotifySlider(screen_id,control_id,value);
					break;
				case kCtrlMeter: //Ǳؼ
					NotifyMeter(screen_id,control_id,value);
					break;
				case kCtrlMenu://˵ؼ
					//cDebug("NotifyMenu(), %d, %d, %d, %d\n", screen_id, control_id, msg->param[0], msg->param[1]);
					NotifyMenu(screen_id,control_id,msg->param[0],msg->param[1]);
					break;
				case kCtrlSelector://ѡؼ
					NotifySelector(screen_id,control_id,msg->param[0]);
					break;
				case kCtrlRTC://ʱؼ
					NotifyTimer(screen_id,control_id);
					break;
				default:
					break;
				}
			}			
		}
		break;
	case NOTIFY_RESET:
		cDebug("NOTIFY_RESET\n");
		NotifyReset();
		break;
	case NOTIFY_ONLINE:
		cDebug("NOTIFY_ONLINE\n");
		SetScreen(MAINPAGE_INDEX);
		break;
	default:
		break;
	}
}

//ıؼʾֵ
void SetTextValueInt32(uint16 screen_id, uint16 control_id,int32 value)
{
	char buffer[12] = {0};
	sprintf(buffer,"%ld",value);
	SetTextValue(screen_id,control_id,(uchar *)buffer);
}

//ַת
int32 StringToInt32(uint8 *str)
{
	int32 v = 0;
	sscanf((char *)str,"%ld",&v);
	return v;
}

//ıؼʾ
void SetTextValueFloat(uint16 screen_id, uint16 control_id, float value)
{
	char buffer[12] = {0};
	sprintf(buffer,"%.1f",value);
	SetTextValue(screen_id,control_id,(uchar *)buffer);
}

//ַת
float StringToFloat(uint8 *str)
{
	int32 v = 0;
	sscanf((char *)str,"%lf",&v);
	return v;
}

/*! 
 *  \brief  λ֪ͨ
 *  \details  ϵ縴λ߱λִд˺
 */
void NotifyReset()
{
	//TODO: û
	SetHandShake();//
}

/*! 
 *  \brief  л֪ͨ
 *  \details  ǰıʱ(GetScreen)ִд˺
 *  \param screen_id ǰID
 */
void NotifyScreen(uint16 screen_id)
{
	//TODO: û
}

/*! 
 *  \brief  ¼Ӧ
 *  \param press 1´3ɿ
 *  \param x x
 *  \param y y
 */
void NotifyTouchXY(uint8 press,uint16 x,uint16 y)
{
	//TODO: û
}

/*! 
 *  \brief  ťؼ֪ͨ
 *  \details  ť״̬ı(GetControlValue)ʱִд˺
 *  \param screen_id ID
 *  \param control_id ؼID
 *  \param state ť״̬01
 */
void NotifyButton(uint16 screen_id, uint16 control_id, uint8  state)
{
	//TODO: û
	switch(screen_id)
	{
		case MAINPAGE_INDEX:
			mainPageButtonProcess(control_id, state);
		break;
		case PROJECTPAGE_INDEX:
			projectPageButtonProcess(control_id, state);
		break;
		case PROJECTEDITPAGE_INDEX:
			projectEditPageButtonProcess(control_id, state);
		break;
		case BACKFLOWPAGE_INDEX:
			backflowPageButtonProcess(control_id, state);
		break;
		case PURGEPAGE_INDEX:
			purgePageButtonProcess(control_id, state);
			break;
		case CALIBRATIONPAGE_INDEX:
			caliPageButtonProcess(control_id, state);
			break;
		case INFORMATIONPAGE_INDEX:
			break;
		case ACTIONPAGE_INDEX:
			actionPageButtonProcess(control_id, state);
			break;
		case RUNNINGPAGE_INDEX:
			runningPageButtonProcess(control_id, state);
			break;
		case TIPS1PAGE_INDEX:
			tips1PageButtonProcess(control_id, state);
			break;
		case TIPS2PAGE_INDEX:
			tips2PageButtonProcess(control_id, state);
			break;
		case PAUSEPAGE_INDEX:
			pausePageButtonProcess(control_id, state);
			break;
		case SELECTPUMPPAGE_INDEX:
			selectPumpPageButtonProcess(control_id, state);
			break;
		default:
			cDebug("cmd_process NotifyButton error!\n");
		break;
	}
}

/*! 
 *  \brief  ıؼ֪ͨ
 *  \details  ı̸ͨ(GetControlValue)ʱִд˺
 *  \param screen_id ID
 *  \param control_id ؼID
 *  \param str ıؼ
 */
void NotifyText(uint16 screen_id, uint16 control_id, uint8 *str)
{
	//TODO: û
	switch(screen_id)
	{
		case PROJECTPAGE_INDEX:
			projectPageEditProcess(control_id, str);
		break;
		case ACTIONPAGE_INDEX:
			actionPageEditProcess(control_id, str);
			break;
		
		default:
			cDebug("cmd_process NotifyText error!\n");
		break;
	}
}

/*! 
 *  \brief  ؼ֪ͨ
 *  \details  GetControlValueʱִд˺
 *  \param screen_id ID
 *  \param control_id ؼID
 *  \param value ֵ
 */
void NotifyProgress(uint16 screen_id, uint16 control_id, uint32 value)
{
	//TODO: û
}

/*! 
 *  \brief  ؼ֪ͨ
 *  \details  ı(GetControlValue)ʱִд˺
 *  \param screen_id ID
 *  \param control_id ؼID
 *  \param value ֵ
 */
void NotifySlider(uint16 screen_id, uint16 control_id, uint32 value)
{
	//TODO: û
}

/*! 
 *  \brief  Ǳؼ֪ͨ
 *  \details  GetControlValueʱִд˺
 *  \param screen_id ID
 *  \param control_id ؼID
 *  \param value ֵ
 */
void NotifyMeter(uint16 screen_id, uint16 control_id, uint32 value)
{
	//TODO: û
}

/*! 
 *  \brief  ˵ؼ֪ͨ
 *  \details  ˵»ɿʱִд˺
 *  \param screen_id ID
 *  \param control_id ؼID
 *  \param item ˵
 *  \param state ť״̬0ɿ1
 */
void NotifyMenu(uint16 screen_id, uint16 control_id, uint8  item, uint8  state)
{
	//TODO: û
	if(state == 1)
		return;

	switch(screen_id)
	{
		case CALIBRATIONPAGE_INDEX:
			caliPageMenuProcess(control_id, item);
		break;
		case ACTIONPAGE_INDEX:
			actionPageMenuProcess(control_id, item);
			break;
		default:
			cDebug("cmd_process NotifyMenu error!\n");
		break;
	}
}

/*! 
 *  \brief  ѡؼ֪ͨ
 *  \details  ѡؼ仯ʱִд˺
 *  \param screen_id ID
 *  \param control_id ؼID
 *  \param item ǰѡ
 */
void NotifySelector(uint16 screen_id, uint16 control_id, uint8  item)
{
	//TODO: û
}

/*! 
 *  \brief  ʱʱ֪ͨ
 *  \param screen_id ID
 *  \param control_id ؼID
 */
void NotifyTimer(uint16 screen_id, uint16 control_id)
{
	//TODO: û
	switch(screen_id)
	{
		case RUNNINGPAGE_INDEX:
			runningPageRTCTimeoutProcess(control_id);
			break;
		default:
			break;
	}
}

/*! 
 *  \brief  ȡûFLASH״̬
 *  \param status 0ʧܣ1ɹ
 *  \param _data 
 *  \param length ݳ
 */
void NotifyReadFlash(uint8 status,uint8 *_data,uint16 length)
{
	//TODO: û
}

/*! 
 *  \brief  дûFLASH״̬
 *  \param status 0ʧܣ1ɹ
 */
void NotifyWriteFlash(uint8 status)
{
	//TODO: û
}

/*! 
 *  \brief  ȡRTCʱ䣬עⷵصBCD
 *  \param year ꣨BCD
 *  \param month £BCD
 *  \param week ڣBCD
 *  \param day գBCD
 *  \param hour ʱBCD
 *  \param minute ֣BCD
 *  \param second 루BCD
 */
void NotifyReadRTC(uint8 year,uint8 month,uint8 week,uint8 day,uint8 hour,uint8 minute,uint8 second)
{
	//TODO: û
}

#ifdef __cplusplus
}
#endif
