#include "timer.h"
#include "io.h"
#include "stddef.h"

idata Timer_TypeDef Timer[TIMER_NUM];//ʱԴ
Timer_TypeDef *hTimer = NULL;//ʱͷָ

//ʱ0ʼ
void Timer0_Init(void)
{
    TMOD |= 0x01;                    //set timer0 as mode1 (16-bit)
    TL0 = TIMEOUT;                   //initial timer0 low byte
    TH0 = TIMEOUT >> 8;              //initial timer0 high byte
    TR0 = 1;                         //timer1 start running
    ET0 = 1;                         //enable timer0 interrupt
}

//-----------------------------------------------
/* Timer0 interrupt routine */
void Timer0_Isr() interrupt 1 using 1
{
	static uint8_t IO_FreDouble = 0;
	uint8_t i;
	Timer_TypeDef *pTimer = NULL;

    TL0 = TIMEOUT;                     //reload timer0 low byte
    TH0 = TIMEOUT >> 8;                //reload timer0 high byte

	//ʱ¶ʱ
	pTimer = hTimer;
	while(pTimer != NULL)
	{
		if(pTimer->Flag & 0x40)//ʱ
		{
			pTimer->Count++;
			if(pTimer->Count == pTimer->Time)
			{
				pTimer->Flag |= 0x80;//ʾʱʱ䵽
				pTimer->Count = 0;

//				if(pTimer->Flag & 0x01)//Զװģʽ
//					pTimer->Count = 0;
//				else
					pTimer->Flag &= ~0x40;//ֹͣʱ	
			}
		}

		pTimer = pTimer->Next;
	}
}

//ʱ
//IDʱţΨһԣжʱԸԼIDҵ
//Timeʱʱ
//Modeʱģʽ1Զװ	0Уδʵ֣
uint8_t Timer_Create(uint8_t ID, uint16_t Time, uint8_t Mode)
{
	Timer_TypeDef *pTimer = NULL;

	if(Timer[ID].Flag & 0x02)//ʱʹ
		return 1;
	
	Timer[ID].Time = Time; //¼ʱʱ
	Timer[ID].Count = 0;//0ʼ
	Timer[ID].Next = 0;//־β
	Timer[ID].Flag = 0x02;//־Ķʱʹ

	if(Mode)
		Timer[ID].Flag |= 0x01;//Զװģʽ

	//ǰûõʱ
	if(hTimer == NULL)
		hTimer =  &Timer[ID];
	else
	{ 	
		//ҵβ
		pTimer = hTimer;
		while(pTimer->Next != NULL)
			pTimer = pTimer->Next;

		pTimer->Next = &Timer[ID];//뵽β	
	}

	return 0;
}

//ʱɾ
uint8_t Timer_Delete(uint8_t ID)
{
	Timer_TypeDef *pTimer = hTimer;
	Timer_TypeDef *pTimer_Last = hTimer;

	//ҵβ
	while(pTimer != NULL)
	{
		if(pTimer == &Timer[ID])
			break;

		pTimer_Last = pTimer;
		pTimer = pTimer->Next;
	}

	if(pTimer == NULL)
		return 1;
	
	if(pTimer == hTimer)//ɾͷ
	{
		ET0 = 0;//ܽ붨ʱж
		hTimer = pTimer->Next;
		ET0 = 1;
	}
	else
	{
	 	ET0 = 0;//ܽ붨ʱж
		pTimer_Last->Next = pTimer->Next;
		ET0 = 1;
	}

	pTimer->Flag = 0x00;//öʱδʹñ־

	return 0;

}

//ʱ
void Timer_Start(uint8_t ID)
{
	Timer[ID].Flag |= 0x40;	
}

//ʱȸλʱʱ䵽־ʱ
void Timer_Restart(uint8_t ID)
{	
	Timer[ID].Flag &= ~0x80;
	Timer[ID].Flag |= 0x40;	
}

//ʱֹͣ
void Timer_Stop(uint8_t ID)
{
	Timer[ID].Flag &= ~0x40;	
}

//ʱλ
void Timer_Reset(uint8_t ID)
{
	Timer[ID].Count = 0;	
}

//ʱʱ
void Timer_ResetTime(uint8_t ID, uint16_t Time)
{
	Timer[ID].Time = Time;	
}

//õʱʱʱ
uint16_t Timer_GetTime(uint8_t ID)
{
	return Timer[ID].Time;	
}

//õʱʱ
uint16_t Timer_GetCount(uint8_t ID)
{
	return Timer[ID].Count;	
}

//Ƿʱʱ䵽
uint8_t Timer_IsTimeOut(uint8_t ID)
{
	return (Timer[ID].Flag & 0x80);
}

//λʱʱ䵽־
void Timer_ResetTimeOutFlag(uint8_t ID)
{
	Timer[ID].Flag &= ~0x80;
}

#if 0
//----------------------------------------------------------------
void Delay1us()		//@24.000MHz
{
	unsigned char i;

	_nop_();
	_nop_();
	i = 3;
	while (--i);
}

void Delay10us()		//@24.000MHz
{
	unsigned char i;

	_nop_();
	_nop_();
	i = 57;
	while (--i);
}

void Delay100us()		//@24.000MHz
{
	unsigned char i, j;

	i = 3;
	j = 82;
	do
	{
		while (--j);
	} while (--i);
}

void Delay1ms()		//@24.000MHz
{
	unsigned char i, j;

	i = 24;
	j = 85;
	do
	{
		while (--j);
	} while (--i);
}

void Delay100ms()		//@24.000MHz
{
	unsigned char i, j, k;

	_nop_();
	_nop_();
	i = 10;
	j = 31;
	k = 147;
	do
	{
		do
		{
			while (--k);
		} while (--j);
	} while (--i);
}

#endif
