#include "stdio.h"
#include "stdarg.h"
#include "uart.h"
#include "../HMI/cmd_queue.h"

#define S2RI  0x01              //S2CON.0
#define S2TI  0x02              //S2CON.1
#define S2RB8 0x04              //S2CON.2
#define S2TB8 0x08              //S2CON.3

//־ڷ
static bit Uart_Busy = 0;
static bit Uart2_Busy = 0;

//ڳʼڲʷõǶʱ1
void Uart_Init(void)
{
	if(BAUD > 9600)
		PCON |= 0x80;	//ʼӱ
	else
		PCON &= ~0x80;

#if (PARITYBIT == NONE_PARITY)
    SCON = 0x50;            //8-bit variable UART
	S2CON = 0x50;
#elif (PARITYBIT == ODD_PARITY) || (PARITYBIT == EVEN_PARITY) || (PARITYBIT == MARK_PARITY)
    SCON = 0xda;            //9-bit variable UART, parity bit initial to 1
	S2CON = 0xda;
#elif (PARITYBIT == SPACE_PARITY)
    SCON = 0xd2;            //9-bit variable UART, parity bit initial to 0
	S2CON = 0xd2;
#endif

	//AUXR = 0x40;      		//ʱ1TģʽһλһҪã벻ж
	//AUXR = 0x54;
	AUXR = 0xD4;			//T0Ϊ1TģʽT1λ1TģʽT1Ϊ1ʷT2Ϊ1Tģʽʱ2T2Ϊ2ʷ
	AUXR1 &= ~0xC0;			//1P30/P31
	TMOD |= 0x20;           //Set Timer1 as 8-bit auto reload mode
	if(BAUD <= 9600)
	{
		TH1 = TL1 = 256 - (FOSC/32/BAUD); //Set auto-reload vaule
	}	 
	else
	{
		TH1 = TL1 = 256 - (FOSC/32/BAUD*2);
	}
	
	T2L = (65536 - (FOSC/4/BAUD));   //òװֵ
	T2H = (65536 - (FOSC/4/BAUD))>>8;

	IE2 = 0x01; 			//ʹܴ2ж	 
	TR1 = 1;                //Timer1 start run
	ES = 1;                 //Enable UART interrupt
}

/*----------------------------
UART interrupt service routine
----------------------------*/
void Uart_Isr() interrupt 4 using 3   //RTXʱж1
{
	uint8_t Buf = SBUF;

    if (RI)
    {			
        RI = 0;             //Clear receive interrupt flag

		//---------------------------------------------------------
		S2BUF = Buf;
		//---------------------------------------------------------
    }
    if (TI)
    {
        TI = 0;             //Clear transmit interrupt flag
        Uart_Busy = 0;           //Clear transmit busy flag
    }
}

/*----------------------------
Send a byte data to UART
Input: Data (data to be sent)
Output:None
----------------------------*/
void Uart_SendData(uint8_t Data)
{
    while (Uart_Busy);    //Wait for the completion of the previous data is sent

    ACC = Data;             //Calculate the even parity bit P (PSW.0)
    if (P)                  //Set the parity bit according to P
    {
#if (PARITYBIT == ODD_PARITY)
        TB8 = 0;            //Set parity bit to 0
#elif (PARITYBIT == EVEN_PARITY)
        TB8 = 1;            //Set parity bit to 1
#endif
    }
    else
    {
#if (PARITYBIT == ODD_PARITY)
        TB8 = 1;            //Set parity bit to 1
#elif (PARITYBIT == EVEN_PARITY)
        TB8 = 0;            //Set parity bit to 0
#endif
    }
    Uart_Busy = 1;
    SBUF = ACC;             //Send data to UART buffer
}

/*----------------------------
Send a string to UART
Input: s (address of string)
Output:None
----------------------------*/
void Uart_SendString(uint8_t *s)
{
    while (*s)              //Check the end of the string
    {
        Uart_SendData(*s++);     //Send current char and increment string ptr
    }
}

/**********************************************************************************************************/

/*----------------------------
UART2 interrupt service routine
----------------------------*/
void Uart2_Isr() interrupt 8 using 3   //RTXʱж1
{
	uint8_t Buf = S2BUF;
	qsize pos;

    if (S2CON & S2RI)
    {
        S2CON &= ~S2RI;         //??S2RI?

		//queue_push(Buf);

		//push
		pos = (que._head+1)%QUEUE_MAX_SIZE;
		if(pos!=que._tail)//״̬
		{
			que._data[que._head] = Buf;
			que._head = pos;
		}

		//Buf = 0x00;
	 	//queue_pop(&Buf);

		//SBUF = Buf;
    }
    if (S2CON & S2TI)
    {
        S2CON &= ~S2TI;         //??S2TI?
        Uart2_Busy = 0;         //æ־
    }
}

/*----------------------------
Send a byte data to UART2
Input: Data (data to be sent)
Output:None
----------------------------*/
void Uart2_SendData(uint8_t dat)
{
    while (Uart2_Busy);               //???????????
    ACC = dat;                  //?????P (PSW.0)
    if (P)                      //??P??????
    {
#if (PARITYBIT == ODD_PARITY)
        S2CON &= ~S2TB8;        //??????0
#elif (PARITYBIT == EVEN_PARITY)
        S2CON |= S2TB8;         //??????1
#endif
    }
    else
    {
#if (PARITYBIT == ODD_PARITY)
        S2CON |= S2TB8;         //??????1
#elif (PARITYBIT == EVEN_PARITY)
        S2CON &= ~S2TB8;        //??????0
#endif
    }
    Uart2_Busy = 1;
    S2BUF = ACC;                //????UART2?????
}

/*----------------------------
Send a string to UART2
Input: s (address of string)
Output:None
----------------------------*/
void Uart2_SendString(char *s)
{
    while (*s)                  //?????????
    {
        Uart2_SendData(*s++);         //??????
    }
}

/**********************************************************************************************************/

void uart_printf(char *fmt,...)//ǵprintf
{
	va_list ap;//typedef char *va_list; va_listchar͵ָ
	
	char xdata string[1024];//ⲿRAM ֽڶ
	
	va_start(ap,fmt);//Ĺǣҵһɱβεĵַѵַap
	vsprintf(string,fmt,ap);//ʵǺĺûо
	Uart_SendString(string);//ǷַͨһͰѸȡĶȡ
	va_end(ap);//
}

void uart_printf_none(char *fmt,...)
{
	;
}
