#ifndef _MANAGERMENT_H_
#define _MANAGERMENT_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "pageCommon.h"
#include "project.h"
#include "../HMI/cmd_queue.h"
#include "../HMI/cmd_process.h"
#include "../HMI/hmi_user_uart.h"

typedef enum
{
	TIPSSOURCE_NONE,

	//tips2ҳ
	TIPSSOURCE_FILLTIPS,
	TIPSSOURCE_RUNNINGPAUSE,
	TIPSSOURCE_RUNNINGSTOP,

	//tips1ҳ
	TIPSSOURCE_PUTWASTETANK,
	TIPSSOURCE_GETWASTETANK,
	TIPSSOURCE_PUTTANK,
	TIPSSOURCE_GETTANK,
	TIPSSOURCE_SAMPLE,
	TIPSSOURCE_MEMBRANCE,
}TipsSource_TypeDef;

typedef enum
{
	TIPS_NONE,
	TIPS_CANCEL,
	TIPS_OK,
}TipsButton_TypeDef;

typedef enum
{
	RUNNING_NONE,
	RUNNING_PROJECT,
	RUNNING_BACKFLOW,
	RUNNING_PURGE,
	RUNNING_CALIBRATION,
}RunningType_TypeDef;

typedef enum
{
	PROJECTSTATUS_IDLE,
	PROJECTSTATUS_SELECTPUMP,
	PROJECTSTATUS_FILLING,
	PROJECTSTATUS_PLACEPLATE,
	PROJECTSTATUS_IMBIBING,
	PROJECTSTATUS_TIPS,
	PROJECTSTATUS_ADDING,
	PROJECTSTATUS_INCUBATION,
	PROJECTSTATUS_TIMEOUT,

	//PROJECTSTATUS_PAUSETIPS,
	PROJECTSTATUS_WAITING,
	PROJECTSTATUS_PAUSE,
}ProjectStatus_TypeDef;

/************************************************************************/
/* Ŀṹ                                                       */
/************************************************************************/
typedef struct
{
	Project_TypeDef *pCurRunningProject;  //ҳ浱ǰеĿ
	Action_TypeDef *pCurRunningAction;  //ҳ浱ǰеĶ
	uint8 curTank;  //ҳ浱ǰĲ
	uint8 curLoopTime;  //ҳ浱ǰڼѭ
	uint8 RTCTimeout;  //ҳRTCʱʱ䵽־0:δ>0:ʱ

	Project_TypeDef *pCurProject;  //Ŀҳ浱ǰѡĿ
	uint8 startTank;  //Ŀҳʼ
	uint8 endTank;  //Ŀҳֹ

	Project_TypeDef *pCurEditProject;  //Ŀ༭ҳ浱ǰ༭Ŀ
	Action_TypeDef *pCurEditAction;  //Ŀ༭ҳ浱ǰ༭Ķ

	Action_TypeDef *pCurJumptoAction;  //ͣҳתѡ

	uint8 backflowPumpSel;  //ҳıѡť״̬
	uint8 purgePumpSel;  //ϴҳıѡť״̬
	uint8 pumpSelPumpSel;  //ѡҳıѡť״̬

	uint8 caliPumpSel;  //У׼ҳıѡť״̬
	float *pCaliPumpPara;  //ʵʵУ׼òб
	float caliAmount;  //У׼ҳʵʼעʱ

	//༭ҳʱ
	Pump_TypeDef pump;//ñ
	Tips_TypeDef tips;//ʾ
	Voice_TypeDef voice;//
	float addAmount;//ע
	uint8 imbiAmout;//Һ
	ShakeSpeed_TypeDef shakeSpeed;//ҡٶ
	ShakeTime_TypeDef shakeTime;//ҡʱ
	uint8 loopTime;//ѭ

	TipsSource_TypeDef tipsSource;  //ʾҳԴͷ
	TipsButton_TypeDef tipsButton;  //ʾҳİť״̬
	RunningType_TypeDef runningType;  //е

	ProjectStatus_TypeDef proStatus;  //ĿĶ
	ProjectStatus_TypeDef preProStatus;  //ĿĶ
}ProjectMan_TypeDef;

/************************************************************************/
/*                                                                      */
/************************************************************************/

extern ProjectMan_TypeDef *pProjectMan;
extern uint8 cmd_buffer[CMD_MAX_SIZE];

void initProjectMan(ProjectMan_TypeDef *pm);
void init(void);

//void uartInterrupt(uint8 data);
//void loopForever(void);

void tipsPageProcess(void);

#ifdef __cplusplus
}
#endif

#endif
